#ifndef NL_SEQ_H
#define NL_SEQ_H

#include <array>
#include "shared.h"
#include "output.h"

namespace nl::seq {
	template<typename elem_t, int DIMS, typename key_t, typename data_t, typename spatial_pred_t, typename score_func_t, typename score_cmp_t>
	void runNl(
		const std::array<range_t<record_t<elem_t, DIMS, key_t, data_t>*>, 2>& inputs,
		spatial_pred_t spatialPred,
		score_func_t scoreFunc,
		top_k_accumulator_t<key_t, std::array<data_t, 2>, score_cmp_t>& output
	) {
		record_t<elem_t, DIMS, key_t, data_t>* inputIters[2];
		for (inputIters[0] = inputs[0].first; inputIters[0] < inputs[0].last; ++inputIters[0]) {
			for (inputIters[1] = inputs[1].first; inputIters[1] < inputs[1].last; ++inputIters[1]) {
				if (spatialPred(inputIters[0]->mbb, inputIters[1]->mbb)) {
					key_t score = scoreFunc(inputIters[0]->key, inputIters[1]->key);
					if (!output.isScoreBelowBound(score)) {
						score_data_pair_t<key_t, std::array<data_t, 2>> outputValue;
						outputValue.score = score;
						outputValue.data[0] = inputIters[0]->data;
						outputValue.data[1] = inputIters[1]->data;
						output.insert(outputValue);
					}
				}
			}
		}
	}
}

#endif //NL_SEQ_H
