#ifndef STR_H
#define STR_H

#include "shared.h"

namespace str {
	template<typename elem_t, int DIMS, typename key_t, typename data_t, typename key_agg_t>
	record_t<elem_t, DIMS, key_t, data_t> createInnerNode(key_agg_t keyAgg, const record_t<elem_t, DIMS, key_t, data_t>* first, const record_t<elem_t, DIMS, key_t, data_t>* last, int childBlock) {
		record_t<elem_t, DIMS, key_t, data_t> result;
		result.mbb = first->mbb;
		result.key = first->key;

		for (auto i = first + 1; i < last; ++i) {
			for (int dim = 0; dim < DIMS; ++dim) {
				result.mbb.min[dim] = std::min(result.mbb.min[dim], i->mbb.min[dim]);
				result.mbb.max[dim] = std::max(result.mbb.max[dim], i->mbb.max[dim]);
			}
			result.key = keyAgg(result.key, i->key);
		}

		result.childBlock = childBlock;
		return result;
	}

	// Compares reccords by a specified dimension
	struct record_dim_cmp_t {
		int dim;

		record_dim_cmp_t(int dim) : dim(dim) {}

		template<typename elem_t, int DIMS, typename key_t, typename data_t>
		bool operator()(const record_t<elem_t, DIMS, key_t, data_t>& lhs, const record_t<elem_t, DIMS, key_t, data_t>& rhs) {
			return lhs.mbb.min[this->dim] < rhs.mbb.min[this->dim];
		}
	};
}

#endif //STR_H
